<template>
  <div id="restaurant-card-list">
    <div id="restaurant-card-list-options" class="card">
      <h3>Filters</h3>
      <div>
        <label>
          Lowest rating
          <select v-model="filter.lowestRating">
            <option value="0">0</option>
            <option value="1">1</option>
            <option value="2">2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
          </select>
        </label>
        <label>
          Highest rating
          <select v-model="filter.highestRating">
            <option value="0">0</option>
            <option value="1">1</option>
            <option value="2">2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
          </select>
        </label>
      </div>
    </div>
    <restaurant-card
    v-for="(restaurant, index) in filteredRestaurantList"
    :class="{ selected : selectedRestaurant._id == restaurant._id }"
    :key="index"
    :restaurant="restaurant">
    </restaurant-card>
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </div>
</template>

<script>
import restaurantCard from './RestaurantCard.vue';
import store from '../store/index';
import { mapState } from 'vuex';
import getAverageRestaurantRating from '../functions/getAverageRestaurantRating';
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  computed: {
    ...mapState([
      'restaurantList',
      'selectedRestaurant',
    ]),
    filteredRestaurantList() {
      return this.restaurantList.filter((restaurant) => (
        getAverageRestaurantRating(restaurant) >= this.filter.lowestRating &&
        getAverageRestaurantRating(restaurant) <= this.filter.highestRating
      )).sort((a, b) => (
        getAverageRestaurantRating(b) - getAverageRestaurantRating(a)
      ));
    },
  },
  data() {
    return {
      filter: {
        lowestRating: 0,
        highestRating: 5,
      },
      loading: false,
    };
  },
  components: {
    restaurantCard,
  },
  created() {
    // avoid getting restaurant list if we already have it
    if (this.restaurantList.length) return;
    // toggle loading spinner on
    this.loading = true;
    // http request
    axios.get(proxy + '/api/restaurants').then((response) => {
      // get restaurants successful
      store.commit('getRestaurantsSuccessful', {
        restaurants: response.data,
      });
      // toggle loading spinner off
      this.loading = false;
    }).catch((error) => {
      // log error message
      console.log({ error: error.message });
      // toggle loading spinner off
      this.loading = false;
    });
  },
}
</script>

<style lang="scss">
#restaurant-card-list-options > div {
  margin-top: -20px;
  display: flex;
  flex-direction: row;
  label {
    margin-right: 20px;
  }
}
</style>
